Index: src/Actions/SelectionAction/Atoms/AllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/AllAtomsAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -45,4 +45,5 @@
   DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms." << endl);
   World::getInstance().selectAllAtoms(AllAtoms());
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms selected." << endl);
   return Action::state_ptr(new SelectionAllAtomsState(selectedAtoms,params));
 }
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -56,4 +56,5 @@
   std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomByShape(s));
   World::getInstance().selectAllAtoms(AtomByShape(s));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms selected." << endl);
   return Action::state_ptr(new SelectionAllAtomsInsideCuboidState(selectedAtoms, s, params));
 }
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -51,4 +51,5 @@
   std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomByShape(s));
   World::getInstance().selectAllAtoms(AtomByShape(s));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms selected." << endl);
   return Action::state_ptr(new SelectionAllAtomsInsideSphereState(selectedAtoms, s, params));
 }
Index: src/Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -47,4 +47,5 @@
   std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection());
   World::getInstance().selectAllAtoms(AtomsByMoleculeSelection());
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms selected." << endl);
   return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(selectedAtoms, params));
 }
Index: src/Actions/SelectionAction/Atoms/AtomByElementAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByElementAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/AtomByElementAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -47,4 +47,5 @@
   std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection());
   World::getInstance().selectAllAtoms(AtomByType(params.elemental));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms selected." << endl);
   return Action::state_ptr(new SelectionAtomByElementState(selectedAtoms,params));
 }
Index: src/Actions/SelectionAction/Atoms/AtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByIdAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/AtomByIdAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -44,4 +44,5 @@
       DoLog(1) && (Log() << Verbose(1) << "Selecting atom " << *params.Walker << endl);
       World::getInstance().selectAtom(params.Walker);
+      DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms selected." << endl);
       return Action::state_ptr(new SelectionAtomByIdState(params));
     } else {
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -45,4 +45,5 @@
   DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms." << endl);
   World::getInstance().clearAtomSelection();
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms remain selected." << endl);
   return Action::state_ptr(new SelectionNotAllAtomsState(selectedAtoms, params));
 }
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -55,4 +55,5 @@
   std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomByShape(s));
   World::getInstance().unselectAllAtoms(AtomByShape(s));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms remain selected." << endl);
   return Action::state_ptr(new SelectionNotAllAtomsInsideCuboidState(unselectedAtoms, s, params));
 }
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -51,4 +51,5 @@
   std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomByShape(s));
   World::getInstance().unselectAllAtoms(AtomByShape(s));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms remain selected." << endl);
   return Action::state_ptr(new SelectionNotAllAtomsInsideSphereState(unselectedAtoms, s, params));
 }
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -47,4 +47,5 @@
   std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms(!AtomsBySelection());
   World::getInstance().unselectAllAtoms(AtomsByMoleculeSelection());
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms remain selected." << endl);
   return Action::state_ptr(new SelectionNotAllAtomsOfMoleculeState(unselectedAtoms, params));
 }
Index: src/Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -47,4 +47,5 @@
   std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms(!AtomsBySelection());
   World::getInstance().unselectAllAtoms(AtomByType(params.elemental));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms remain selected." << endl);
   return Action::state_ptr(new SelectionNotAtomByElementState(unselectedAtoms,params));
 }
Index: src/Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -44,4 +44,5 @@
       DoLog(1) && (Log() << Verbose(1) << "Unselecting atom " << *params.Walker << endl);
       World::getInstance().unselectAtom(params.Walker);
+      DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedAtoms() << " atoms remain selected." << endl);
       return Action::state_ptr(new SelectionNotAtomByIdState(params));
     } else {
Index: src/Actions/SelectionAction/Molecules/AllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/AllMoleculesAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/AllMoleculesAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -46,4 +46,5 @@
   DoLog(1) && (Log() << Verbose(1) << "Selecting all molecules." << endl);
   World::getInstance().selectAllMolecules(AllMolecules());
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules selected." << endl);
   return Action::state_ptr(new SelectionAllMoleculesState(selectedMolecules,params));
 }
Index: src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -45,4 +45,5 @@
   DoLog(1) && (Log() << Verbose(1) << "Clearing molecule selection." << endl);
   World::getInstance().clearMoleculeSelection();
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules remain selected." << endl);
   return Action::state_ptr(new SelectionClearAllMoleculesState(selectedMolecules,params));
 }
Index: src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -50,4 +50,5 @@
 //    DoLog(1) && (Log() << Verbose(1) << "\t" << mol->getId() << ", " << mol->getName() << "." << endl);
   World::getInstance().selectAllMolecules(MoleculeByFormula(params.formula));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules selected." << endl);
   return Action::state_ptr(new SelectionMoleculeByFormulaState(selectedMolecules,params));
 }
Index: src/Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -44,4 +44,5 @@
       DoLog(1) && (Log() << Verbose(1) << "Selecting molecule " << params.mol->name << endl);
       World::getInstance().selectMolecule(params.mol);
+      DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules selected." << endl);
       return Action::state_ptr(new SelectionMoleculeByIdState(params));
     } else {
Index: src/Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -47,4 +47,5 @@
       World::getInstance().getAllMolecules(MoleculesBySelection() && MoleculeByName(params.molname));
   World::getInstance().selectAllMolecules(MoleculeByName(params.molname));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules selected." << endl);
 
   return Action::state_ptr(new SelectionMoleculeByNameState(selectedMolecules,params));
Index: src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -48,4 +48,5 @@
       DoLog(1) && (Log() << Verbose(1) << "Selecting molecule " << mol->name << endl);
       World::getInstance().selectMolecule(mol);
+      DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules selected." << endl);
       return Action::state_ptr(new SelectionMoleculeByOrderState(mol, params));
     } else {
Index: src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -45,4 +45,5 @@
   DoLog(1) && (Log() << Verbose(1) << "Selecting molecule to currently selected atoms." << endl);
   World::getInstance().selectAllMolecules(MoleculesByAtomSelection());
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules selected." << endl);
   return Action::state_ptr(new SelectionMoleculeOfAtomState(selectedMolecules, params));
 }
Index: src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -45,4 +45,5 @@
   DoLog(1) && (Log() << Verbose(1) << "Unselecting all molecules." << endl);
   World::getInstance().clearMoleculeSelection();
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules remain selected." << endl);
   return Action::state_ptr(new SelectionNotAllMoleculesState(selectedMolecules,params));
 }
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -47,4 +47,5 @@
   std::vector<molecule *> unselectedMolecules = World::getInstance().getAllMolecules(!MoleculesBySelection());
   World::getInstance().unselectAllMolecules(MoleculeByFormula(params.formula));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules remain selected." << endl);
   return Action::state_ptr(new SelectionNotMoleculeByFormulaState(unselectedMolecules,params));
 }
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -44,4 +44,5 @@
       DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule " << params.mol->name << endl);
       World::getInstance().unselectMolecule(params.mol);
+      DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules remain selected." << endl);
       return Action::state_ptr(new SelectionNotMoleculeByIdState(params));
     } else {
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -47,4 +47,5 @@
       World::getInstance().getAllMolecules((!MoleculesBySelection()) && MoleculeByName(params.molname));
   World::getInstance().unselectAllMolecules(MoleculeByName(params.molname));
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules remain selected." << endl);
 
   return Action::state_ptr(new SelectionNotMoleculeByNameState(unselectedMolecules,params));
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -48,4 +48,5 @@
       DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule " << mol->name << endl);
       World::getInstance().unselectMolecule(mol);
+      DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules remain selected." << endl);
       return Action::state_ptr(new SelectionNotMoleculeByOrderState(mol, params));
     } else {
Index: src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.cpp	(revision d1115de89a5962b3b03f159e145f3860d6a3b410)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.cpp	(revision aa4b2d50a6822ca41e873badba032107ce6d6d6d)
@@ -45,4 +45,5 @@
   DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule to currently selected atoms." << endl);
   World::getInstance().unselectAllMolecules(MoleculesByAtomSelection());
+  DoLog(0) && (Log() << Verbose(0) << World::getInstance().countSelectedMolecules() << " molecules remain selected." << endl);
   return Action::state_ptr(new SelectionNotMoleculeOfAtomState(unselectedMolecules, params));
 }
